module accum (dt, clk, sc, lr, theta) ;

input [15:0] dt ;
input clk ;
input sc ;
input lr ;
output [9:0] theta ;

reg [31:0] count;
reg [15:0] out0;
reg [15:0] out1;
reg init;
reg lrprev;
wire up;
wire down;

assign up = lr && ~lrprev;
assign down = ~lr && lrprev;
assign theta = lr ? out0[15:6] : out1[15:6];

always @ (posedge clk) begin
  if (~init) begin
    out0 <= 0;
    out1 <= 0;
    init <= 1;
  end

  if (up)
    out0 <= out0 + dt;
  if (down)
    out1 <= out1 + dt;

  lrprev <= lr;  
end

endmodule 
