module accumulator (CLK, dt, lr, sc, theta) ;

input CLK ;
input lr, sc;
input [15:0] dt;
output [9:0] theta;

// add your declarations here

reg [31:0] count;
reg [15:0] out;
reg init;
reg lrprev;

assign theta = out[15:6];

always @ (posedge CLK) begin
  if (~init) begin
    out <= 0;
    init <= 1;
  end

  if (lr && ~lrprev)
    out <= out + dt;

  lrprev <= lr;  
end

endmodule 

