module Average (DATAL, DATAR, SCLK, LRCK, DATALOUT, DATAROUT, BTN2, BTN3) ;

input [19:0] DATAL ;
input [19:0] DATAR ;
input LRCK ;
input BTN2, BTN3 ;
output [19:0] DATALOUT ;
output [19:0] DATAROUT ;
input SCLK ;

reg [1:0] state;
reg [19:0] OLDDATAR;
reg [19:0] OLDDATAL;

reg [19:0] DATALOUT;
reg [19:0] DATAROUT;

reg oldlrclk;

// add your declarations here
`define doaverage 1
`define passthrough 0
`define difference 2


always @(posedge SCLK) begin
	oldlrclk <= LRCK;

	if(BTN2)
		state = `doaverage;
	else if(BTN3)
		state = `difference;
	else
		state = `passthrough;

	if(LRCK ^ oldlrclk) begin
		if(oldlrclk) 
			OLDDATAL <= DATAL; 	
		else
			OLDDATAR <= DATAR; 	
	
		case(state)
			`passthrough: begin
				DATALOUT = DATAL;
				DATAROUT = DATAR;
			end
		
			`doaverage: begin
				if(oldlrclk) 
					DATALOUT = (DATAL + OLDDATAL) >> 1;
				else
					DATAROUT = (DATAR + OLDDATAR) >> 1;	
			end
			`difference: begin
			
				if(oldlrclk) begin 
					if(DATAL > OLDDATAL)
						DATALOUT = DATAL - OLDDATAL;
					else
						DATALOUT = OLDDATAL - DATAL;
				end	
				else begin
					if(DATAR > OLDDATAR)
						DATAROUT = DATAR - OLDDATAR;
					else
						DATAROUT = OLDDATAR - DATAR;
				end
	
			end
			
		endcase
		
	end

end

endmodule 
