module AVG (DL, DR, LRCLK, SCLK, SER_OUT) ;

input [19:0] DL ;
input [19:0] DR ;
input LRCLK ;
input SCLK ;
output SER_OUT ;

reg SER_OUT;
reg OLDLRCLK;
reg [19:0] rdata;
reg [19:0] ldata;
reg [19:0] oldrdata; 
reg [20:0] avg;

always @(posedge SCLK) OLDLRCLK <= LRCLK; 
 
always @(posedge SCLK) begin 
	if (LRCLK ^ OLDLRCLK) begin 
           	
           	// load in new sample
           	if (OLDLRCLK) begin
           		oldrdata = ~(rdata) + 1;
           		rdata = DR;
           	end
                else begin
                	ldata = DL;
               	end
               	
               	// same sign
               	if(~(oldrdata[19] ^ rdata[19])) begin
               	avg = oldrdata + rdata;	    	
               	end
               	
               	// opposite signs
               	else begin
		avg = oldrdata + rdata;
		avg = {avg[19], avg[19:0]};               	
                end
                
 	// divide (sort of) 
 	//avg = avg >> 1;
 	 	
        end 
	SER_OUT = avg[19]; 
	avg = avg << 1; 
end
endmodule 
