module AVG_EFFECT (LI, RI, LRCK, SCLK, LO, RO) ;

input [19:0] LI;
input [19:0] RI;
input LRCK, SCLK;
output [19:0] LO;
output [19:0] RO;
reg [19:0] LO;
reg [19:0] RO;
reg [19:0] lt1;
reg [19:0] lt2;
reg [19:0] rt1;
reg [19:0] rt2;
reg oldlrck;

always @(posedge SCLK) oldlrck <= LRCK;

// whenever LRCK changes
always @(posedge SCLK) begin
	// if (LR edge detected)
        if (LRCK ^ oldlrck) begin
        	// handle the left channel
		if (oldlrck) begin
			// save L[n-1]
			lt1 <= LI;
			// lt2 = L[n] + L[n-1]
			lt2 = lt1 + LI;
			// lt2 = lt2 / 2
			if(lt2[19]) 
				LO = {1,lt2[19:1]};
			else
				LO = {0,lt2[19:1]};
		end
		// handle the right channel
		else begin
			// save R[n-1]
			rt1 <= RI;
			// rt2 = R[n] + R[n-1]
			rt2 = rt1 + RI;
			// rt2 = rt2 / 2
			if(rt2[19])
				RO = {1,rt2[19:1]};
			else
				RO = {0,rt2[19:1]};
		end
	end

end

endmodule 
