module decay (sine3, sine4, sine5, noteon, newsignal, velocity, next, LR, CLK, out3, out4, out5) ;

input [15:0] sine3 ;
input [15:0] sine4 ;
input [15:0] sine5 ;
input noteon ;
input newsignal ;
input [7:0] velocity ;
input [3:0] next ;
input LR ;
input CLK ;
output [15:0] out3 ;
output [15:0] out4 ;
output [15:0] out5 ;

// add your declarations here

  //these counters will count between decay stages
reg [15:0] out3 ;
reg [15:0] out4 ;
reg [15:0] out5 ;


reg [12:0] counter3 ;
reg [12:0] counter4 ;
reg [12:0] counter5 ;
reg [12:0] counter9 ;
reg [12:0] counter10 ;
reg [12:0] counter11 ;


reg [3:0] state3 ;
reg [3:0] state4 ;
reg [3:0] state5 ;
reg [3:0] state9 ;
reg [3:0] state10 ;
reg [3:0] state11 ;

reg prevLR ;

// add your code here


always @(posedge CLK) begin

  prevLR <= LR;
  
  if (LR && ~prevLR) begin


    if (counter3 < 7200) begin
  	counter3 <= counter3 + 1;
    end
    else if (state3 < 12) begin
       state3 <= state3 + 1;
       counter3 <= 0;
    end
    if (counter4 < 7200) begin
  	counter4 <= counter4 + 1;
    end
    else if (state4 < 12) begin
       state4 <= state4 + 1;
       counter4 <= 0;
    end
    if (counter5 < 7200) begin
  	counter5 <= counter5 + 1;
    end
    else if (state5 < 12) begin
       state5 <= state5 + 1;
       counter5 <= 0;
    end

    if (counter9 < 7200) begin
  	counter9 <= counter9 + 1;
    end
    else if (state9 < 12) begin
       state9 <= state9 + 1;
       counter9 <= 0;
    end
    if (counter10 < 7200) begin
  	counter10 <= counter10 + 1;
    end
    else if (state10 < 12) begin
       state10 <= state10 + 1;
       counter10 <= 0;
    end
    if (counter11 < 7200) begin
  	counter11 <= counter11 + 1;
    end
    else if (state11 < 12) begin
       state11 <= state11 + 1;
       counter11 <= 0;
    end
  end


  if (newsignal && noteon) begin

    if (next == 3) begin
      counter3 <= 0;
      state3 <= 0;
    end  
    if (next == 4) begin
      counter4 <= 0;
      state4 <= 0;
    end  
    if (next == 5) begin
      counter5 <= 0;
      state5 <= 0;
    end  

    if (next == 9) begin
      counter9 <= 0;
      state9 <= 0;
    end  
    if (next == 10) begin
      counter10 <= 0;
      state10 <= 0;
    end  
    if (next == 11) begin
      counter11 <= 0;
      state11 <= 0;
    end  
  end


  if (LR) begin


    // channel 3 state changes
    if ((state3 == 0) || (state3 == 6)) begin
      out3[12:0] <= sine3[15:3];
      out3[15:13] <= 0;
    end
    if ((state3 == 1) || (state3 == 5)) begin
      out3[13:0] <= sine3[15:2];
      out3[15:14] <= 0;
    end
    if ((state3 == 2) || (state3 == 4)) begin
      out3[14:0] <= sine3[15:1];
      out3[15] <= 0;
    end
    if (state3 == 3) begin
      out3 <= sine3;
    end
    if (state3 == 7) begin
      out3[11:0] <= sine3[15:4];
      out3[15:12] <= 0;
    end
    if (state3 == 8) begin
      out3[10:0] <= sine3[15:5];
      out3[15:11] <= 0;
    end
    if (state3 == 9) begin
      out3[9:0] <= sine3[15:6];
      out3[15:10] <= 0;
    end
    if (state3 == 10) begin
      out3[8:0] <= sine3[15:7];
      out3[15:9] <= 0;
    end



    // channel 4 state changes
    if ((state4 == 0) || (state4 == 6)) begin
      out4[12:0] <= sine4[15:3];
      out4[15:13] <= 0;
    end
    if ((state4 == 1) || (state4 == 5)) begin
      out4[13:0] <= sine4[15:2];
      out4[15:14] <= 0;
    end
    if ((state4 == 2) || (state4 == 4)) begin
      out4[14:0] <= sine4[15:1];
      out4[15] <= 0;
    end
    if (state4 == 3) begin
      out4 <= sine4;
    end
    if (state4 == 7) begin
      out4[11:0] <= sine4[15:4];
      out4[15:12] <= 0;
    end
    if (state4 == 8) begin
      out4[10:0] <= sine4[15:5];
      out4[15:11] <= 0;
    end
    if (state4 == 9) begin
      out4[9:0] <= sine4[15:6];
      out4[15:10] <= 0;
    end
    if (state4 == 10) begin
      out4[8:0] <= sine4[15:7];
      out4[15:9] <= 0;
    end



    // channel 5 state changes
    if ((state5 == 0) || (state5 == 6)) begin
      out5[12:0] <= sine5[15:3];
      out5[15:13] <= 0;
    end
    if ((state5 == 1) || (state5 == 5)) begin
      out5[13:0] <= sine5[15:2];
      out5[15:14] <= 0;
    end
    if ((state5 == 2) || (state5 == 4)) begin
      out5[14:0] <= sine5[15:1];
      out5[15] <= 0;
    end
    if (state5 == 3) begin
      out5 <= sine5;
    end
    if (state5 == 7) begin
      out5[11:0] <= sine5[15:4];
      out5[15:12] <= 0;
    end
    if (state5 == 8) begin
      out5[10:0] <= sine5[15:5];
      out5[15:11] <= 0;
    end
    if (state5 == 9) begin
      out5[9:0] <= sine5[15:6];
      out5[15:10] <= 0;
    end
    if (state5 == 10) begin
      out5[8:0] <= sine5[15:7];
      out5[15:9] <= 0;
    end

  end else begin




    // channel 9 state changes
    if ((state9 == 0) || (state9 == 6)) begin
      out3[12:0] <= sine3[15:3];
      out3[15:13] <= 0;
    end
    if ((state9 == 1) || (state9 == 5)) begin
      out3[13:0] <= sine3[15:2];
      out3[15:14] <= 0;
    end
    if ((state9 == 2) || (state9 == 4)) begin
      out3[14:0] <= sine3[15:1];
      out3[15] <= 0;
    end
    if (state9 == 3) begin
      out3 <= sine3;
    end
    if (state9 == 7) begin
      out3[11:0] <= sine3[15:4];
      out3[15:12] <= 0;
    end
    if (state9 == 8) begin
      out3[10:0] <= sine3[15:5];
      out3[15:11] <= 0;
    end
    if (state9 == 9) begin
      out3[9:0] <= sine3[15:6];
      out3[15:10] <= 0;
    end
    if (state9 == 10) begin
      out3[8:0] <= sine3[15:7];
      out3[15:9] <= 0;
    end





    // channel 10 state changes
    if ((state10 == 0) || (state10 == 6)) begin
      out4[12:0] <= sine4[15:3];
      out4[15:13] <= 0;
    end
    if ((state10 == 1) || (state10 == 5)) begin
      out4[13:0] <= sine4[15:2];
      out4[15:14] <= 0;
    end
    if ((state10 == 2) || (state10 == 4)) begin
      out4[14:0] <= sine4[15:1];
      out4[15] <= 0;
    end
    if (state10 == 3) begin
      out4 <= sine4;
    end
    if (state10 == 7) begin
      out4[11:0] <= sine4[15:4];
      out4[15:12] <= 0;
    end
    if (state10 == 8) begin
      out4[10:0] <= sine4[15:5];
      out4[15:11] <= 0;
    end
    if (state10 == 9) begin
      out4[9:0] <= sine4[15:6];
      out4[15:10] <= 0;
    end
    if (state10 == 10) begin
      out4[8:0] <= sine4[15:7];
      out4[15:9] <= 0;
    end





    // channel 11 state changes
    if ((state11 == 0) || (state11 == 6)) begin
      out5[12:0] <= sine5[15:3];
      out5[15:13] <= 0;
    end
    if ((state11 == 1) || (state11 == 5)) begin
      out5[13:0] <= sine5[15:2];
      out5[15:14] <= 0;
    end
    if ((state11 == 2) || (state11 == 4)) begin
      out5[14:0] <= sine5[15:1];
      out5[15] <= 0;
    end
    if (state11 == 3) begin
      out5 <= sine5;
    end
    if (state11 == 7) begin
      out5[11:0] <= sine5[15:4];
      out5[15:12] <= 0;
    end
    if (state11 == 8) begin
      out5[10:0] <= sine5[15:5];
      out5[15:11] <= 0;
    end
    if (state11 == 9) begin
      out5[9:0] <= sine5[15:6];
      out5[15:10] <= 0;
    end
    if (state11 == 10) begin
      out5[8:0] <= sine5[15:7];
      out5[15:9] <= 0;
    end

  end
end

endmodule 
