module Differ (DataL, lrclk, sclk, DataL_out) ;

input [19:0] DataL ;
input lrclk ;
input sclk ;
output [19:0] DataL_out ;

// add your declarations here
reg [19:0] old_data;
reg oldlrclk;
reg DataL_out;
reg [19:0] compA;
reg [19:0] compB;

// add your code here
always @(posedge sclk) oldlrclk <= lrclk;

always @(posedge sclk) begin
	if(lrclk ^ oldlrclk) begin
		if(!oldlrclk) begin
			old_data <= DataL;
		end
		
		// Comvert any negative 2's complement to positive
		// compA and compB will both be postive numbers
		if(old_data[19] == 1) compA = (~old_data) + 1;
		else compA = old_data;
		
		if(DataL[19] == 1) compB = (~DataL) + 1;
		else compB = DataL;
		
		if(old_data[19] ^ DataL[19]) 
			// One negative and one positive number
			DataL_out = compA + compB;
		else
			// Both numebrs are positive or negative
			// The difference will always be positve or zero
			if(compA > compB) DataL_out = compA - compB;
			else DataL_out = compB- compA;
	end
end

endmodule 
