module DIFF_EFFECT (LI, RI, LRCK, SCLK, LO, RO) ;

input [19:0] LI;
input [19:0] RI;
input LRCK, SCLK;
output [19:0] LO;
output [19:0] RO;
reg [19:0] LO;
reg [19:0] RO;
reg [19:0] lt1;
reg [19:0] lt2;
reg [19:0] rt1;
reg [19:0] rt2;
reg oldlrck;

always @(posedge SCLK) oldlrck <= LRCK;

// whenever LRCK changes
always @(posedge SCLK) begin
	// if (LR edge detected)
        if (LRCK ^ oldlrck) begin
        	// handle the left channel
		if (oldlrck) begin
			// save L[n-1]
			lt1 <= ~LI +1;
			// LO = L[n] - L[n-1] (negate second operand and add)
			//lt2 = !lt1;
			//lt2 = lt2 + 1;
			LO = LI + lt1;
		end
		// handle the right channel
		else begin
			// save R[n-1]
			rt1 <= ~RI +1;
			// RO = R[n] - R[n-1] (negate second operand and add)
			//rt2 = !rt1;
			//rt2 = rt2 + 1;
			RO = RI + rt1;

		end
	end

end

endmodule 
