module generator (clk, reset, lr, newinput, mType, innote, invel, dt0, dt1, dt2, dt3, dt4, dt5, testbutt, next) ;

// inputs / outputs
output [15:0] dt0 ;
output [15:0] dt1 ;
output [15:0] dt2 ;
output [15:0] dt3 ;
output [15:0] dt4 ;
output [15:0] dt5 ;
output [3:0] next ;
input clk, reset, lr, testbutt;
input newinput, mType; // that there is a valid input, and mType is noteon (if a 1) or noteoff (if a 0)
input [7:0] innote, invel; // input note number, input velocity
//output newnote;
//output [3:0] notenum;
//output [2:0] velocity;


// the 12 simultaneous notes
reg [15:0] d0, d1, d2, d3, d4, d5, d6, d7, d8, d9, d10, d11;
reg [25:0] c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11;

reg [3:0] next; // the next line (0 through 11)
reg writedt, readdt;
reg [15:0] deltatheta;

// assign the output to the 12 registers based on the lr clock
assign dt0 = (lr) ? d0 : d6;
assign dt1 = (lr) ? d1 : d7;
assign dt2 = (lr) ? d2 : d8;
assign dt3 = (lr) ? d3 : d9;
assign dt4 = (lr) ? d4 : d10;
assign dt5 = (lr) ? d5 : d11;



// delta thetas for all of the notes in the five octaves
// CS means C-Sharp, not Computer Science.
// number is octave number
parameter C1 = 179;
parameter CS1 = 189;
parameter D1 = 200;
parameter DS1 = 212;
parameter E1 = 225;
parameter F1 = 238;
parameter FS1 = 253;
parameter G1 = 268;
parameter GS1 = 284;
parameter A1 = 300;
parameter AS1 = 318;
parameter B1 = 337;
parameter C2 = 357;
parameter CS2 = 378;
parameter D2 = 401;
parameter DS2 = 425;
parameter E2 = 450;
parameter F2 = 477;
parameter FS2 = 505;
parameter G2 = 535;
parameter GS2 = 567;
parameter A2 = 601;
parameter AS2 = 637;
parameter B2 = 674;
parameter C3 = 714;
parameter CS3 = 757;
parameter D3 = 802;
parameter DS3 = 850;
parameter E3 = 900;
parameter F3 = 954;
parameter FS3 = 1010;
parameter G3 = 1070;
parameter GS3 = 1134;
parameter A3 = 1201;
parameter AS3 = 1273;
parameter B3 = 1349;
parameter C4 = 1429;
parameter CS4 = 1514;
parameter D4 = 1604;
parameter DS4 = 1699;
parameter E4 = 1800;
parameter F4 = 1907;
parameter FS4 = 2021;
parameter G4 = 2141;
parameter GS4 = 2268;
parameter A4 = 2403;
parameter AS4 = 2546;
parameter B4 = 2697;
parameter C5 = 2857;
parameter CS5 = 3028;
parameter D5 = 3208;
parameter DS5 = 3398;
parameter E5 = 3600;
parameter F5 = 3814;
parameter FS5 = 4041;
parameter G5 = 4282;
parameter GS5 = 4536;
parameter A5 = 4806;
parameter AS5 = 5092;
parameter B5 = 5395;

// end parameters




always @(posedge clk) begin

  if (reset) begin
    next <= 0;
    d0 <= 0;
    d1 <= 0;
    d2 <= 0;
    d3 <= 0;
    d4 <= 0;
    d5 <= 0;
    d6 <= 0;
    d7 <= 0;
    d8 <= 0;
    d9 <= 0;
    d10 <= 0;
    d11 <= 0;
  end else if (testbutt) begin
    d0 <= 100;
    d1 <= 100;
    d2 <= 100;
    d3 <= 100;
    d4 <= 100;
    d5 <= 100;
    d6 <= 100;
    d7 <= 100;
    d8 <= 100;
    d9 <= 100;
    d10 <= 100;
    d11 <= 100;
  end

  if (c0 >= 50000000)
    d0 <= 0;
  else
    c0 <= c0 + 1;

  if (c1 >= 50000000)
    d1 <= 0;
  else
    c1 <= c1 + 1;

  if (c2 >= 50000000)
    d2 <= 0;
  else
    c2 <= c2 + 1;

  if (c3 >= 50000000)
    d3 <= 0;
  else
    c3 <= c3 + 1;

  if (c4 >= 50000000)
    d4 <= 0;
  else
    c4 <= c4 + 1;

  if (c5 >= 50000000)
    d5 <= 0;
  else
    c5 <= c5 + 1;

  if (c6 >= 50000000)
    d6 <= 0;
  else
    c6 <= c6 + 1;

  if (c7 >= 50000000)
    d7 <= 0;
  else
    c7 <= c7 + 1;

  if (c8 >= 50000000)
    d8 <= 0;
  else
    c8 <= c8 + 1;

  if (c9 >= 50000000)
    d9 <= 0;
  else
    c9 <= c9 + 1;

  if (c10 >= 50000000)
    d10 <= 0;
  else
    c10 <= c10 + 1;

  if (c11 >= 50000000)
    d11 <= 0;
  else
    c11 <= c11 + 1;


  if (newinput) begin
    if (mType)  // noteon message
      writedt <= 1;
    else
      readdt <= 1;
      
    if (innote == 36) deltatheta <= C1;
    else if (innote == 37) deltatheta <= CS1;
    else if (innote == 38) deltatheta <= D1;
    else if (innote == 39) deltatheta <= DS1;
    else if (innote == 40) deltatheta <= E1;
    else if (innote == 41) deltatheta <= F1;
    else if (innote == 42) deltatheta <= FS1;
    else if (innote == 43) deltatheta <= G1;
    else if (innote == 44) deltatheta <= GS1;
    else if (innote == 45) deltatheta <= A1;
    else if (innote == 46) deltatheta <= AS1;
    else if (innote == 47) deltatheta <= B1;
    else if (innote == 48) deltatheta <= C2;
    else if (innote == 49) deltatheta <= CS2;
    else if (innote == 50) deltatheta <= D2;
    else if (innote == 51) deltatheta <= DS2;
    else if (innote == 52) deltatheta <= E2;
    else if (innote == 53) deltatheta <= F2;
    else if (innote == 54) deltatheta <= FS2;
    else if (innote == 55) deltatheta <= G2;
    else if (innote == 56) deltatheta <= GS2;
    else if (innote == 57) deltatheta <= A2;
    else if (innote == 58) deltatheta <= AS2;
    else if (innote == 59) deltatheta <= B2;
    else if (innote == 60) deltatheta <= C3;
    else if (innote == 61) deltatheta <= CS3;
    else if (innote == 62) deltatheta <= D3;
    else if (innote == 63) deltatheta <= DS3;
    else if (innote == 64) deltatheta <= E3;
    else if (innote == 65) deltatheta <= F3;
    else if (innote == 66) deltatheta <= FS3;
    else if (innote == 67) deltatheta <= G3;
    else if (innote == 68) deltatheta <= GS3;
    else if (innote == 69) deltatheta <= A3;
    else if (innote == 70) deltatheta <= AS3;
    else if (innote == 71) deltatheta <= B3;
    else if (innote == 72) deltatheta <= C4;
    else if (innote == 73) deltatheta <= CS4;
    else if (innote == 74) deltatheta <= D4;
    else if (innote == 75) deltatheta <= DS4;
    else if (innote == 76) deltatheta <= E4;
    else if (innote == 77) deltatheta <= F4;
    else if (innote == 78) deltatheta <= FS4;
    else if (innote == 79) deltatheta <= G4;
    else if (innote == 80) deltatheta <= GS4;
    else if (innote == 81) deltatheta <= A4;
    else if (innote == 82) deltatheta <= AS4;
    else if (innote == 83) deltatheta <= B4;
    else if (innote == 84) deltatheta <= C5;
    else if (innote == 85) deltatheta <= CS5;
    else if (innote == 86) deltatheta <= D5;
    else if (innote == 87) deltatheta <= DS5;
    else if (innote == 88) deltatheta <= E5;
    else if (innote == 89) deltatheta <= F5;
    else if (innote == 90) deltatheta <= FS5;
    else if (innote == 91) deltatheta <= G5;
    else if (innote == 92) deltatheta <= GS5;
    else if (innote == 93) deltatheta <= A5;
    else if (innote == 94) deltatheta <= AS5;
    else if (innote == 95) deltatheta <= B5;
    else deltatheta <= C1;
      
    if (next == 0) begin 
      c0 <= 0;
    end else if (next == 1) begin
      c1 <= 0;
    end else if (next == 2) begin
      c2 <= 0;
    end else if (next == 3) begin
      c3 <= 0;
    end else if (next == 4) begin
      c4 <= 0;
    end else if (next == 5) begin
      c5 <= 0;
    end else if (next == 6) begin
      c6 <= 0;
    end else if (next == 7) begin
      c7 <= 0;
    end else if (next == 8) begin
      c8 <= 0;
    end else if (next == 9) begin
      c9 <= 0;
    end else if (next == 10) begin
      c10 <= 0;
    end else begin
      c11 <= 0;
    end
    
  end else if (writedt) begin
    writedt <= 0;
    if (next == 0) begin 
      d0 <= deltatheta;
      c0 <= 0;
    end else if (next == 1) begin
      d1 <= deltatheta;
      c1 <= 0;
    end else if (next == 2) begin
      d2 <= deltatheta;
      c2 <= 0;
    end else if (next == 3) begin
      d3 <= deltatheta;
      c3 <= 0;
    end else if (next == 4) begin
      d4 <= deltatheta;
      c4 <= 0;
    end else if (next == 5) begin
      d5 <= deltatheta;
      c5 <= 0;
    end else if (next == 6) begin
      d6 <= deltatheta;
      c6 <= 0;
    end else if (next == 7) begin
      d7 <= deltatheta;
      c7 <= 0;
    end else if (next == 8) begin
      d8 <= deltatheta;
      c8 <= 0;
    end else if (next == 9) begin
      d9 <= deltatheta;
      c9 <= 0;
    end else if (next == 10) begin
      d10 <= deltatheta;
      c10 <= 0;
    end else begin
      d11 <= deltatheta;
      c11 <= 0;
    end
    
    if (next >= 11) 
      next <= 0;
    else 
      next <= next + 1;
      
  end else if (readdt) begin
    readdt <= 0;
    if (deltatheta == d0) d0 <= 0;
    if (deltatheta == d1) d1 <= 0;
    if (deltatheta == d2) d2 <= 0;
    if (deltatheta == d3) d3 <= 0;
    if (deltatheta == d4) d4 <= 0;
    if (deltatheta == d5) d5 <= 0;
    if (deltatheta == d6) d6 <= 0;
    if (deltatheta == d7) d7 <= 0;
    if (deltatheta == d8) d8 <= 0;
    if (deltatheta == d9) d9 <= 0;
    if (deltatheta == d10) d10 <= 0;
    if (deltatheta == d11) d11 <= 0;
  end
end

endmodule 












































