module SPReceiver (serial, clk, reset, new, noteon, notenum, velocity) ;

input serial ;
input clk ;
input reset;
output new ;
output noteon ;
output [7:0] notenum ;
output [7:0] velocity ;

//wire [7:0] mType;
wire [7:0] out;
wire newb;

reg [1:0] bytenum;

reg new;
reg [7:0] mType, notenum, velocity;

bytereader br(clk, serial, reset, newb, out);

assign noteon = (mType == 144);


//assign new = newb && (bytenum == 2) && (mType == 128 || mType == 144);
//assign mType = (newb && (bytenum == 0)) ? out : mType;
//assign notenum = (newb && (bytenum == 1)) ? out : notenum;
//assign velocity = (newb && (bytenum == 2)) ? out : velocity;


always @(posedge clk) begin
//  if (reset)
//    bytenum <= 0;
  if (newb) begin
    if (bytenum == 2 && (mType == 128 || mType == 144))
      new <= 1;
  
    if (bytenum == 0 || out == 128 || out == 144)
      mType <= out;
    else if (bytenum == 1)
      notenum <= out;
    else if (bytenum == 2)
      velocity <= out;

    if (out == 128 || out == 144)
      bytenum <= 1;    
    else if (bytenum < 2)
      bytenum <= bytenum + 1;
    else
      bytenum <= 0;
  end else
    new <= 0;
end

endmodule 



module bytereader (clk, serial, reset, new, out);

input clk, serial, reset;
output new;
output [7:0] out;

reg new;
reg [7:0] out;

reg reading;
reg [11:0] cnt;
reg [4:0] bitnum;


always @(posedge clk) begin
//  if (reset)
//    reading <= 0;
  if (! reading) begin
    new <= 0;
    if (! serial) begin
      reading <= 1; // start bit: means we have a new byte
      cnt <= 1192; // setup to go through to midway through the first bit
      bitnum <= 0;
    end
  end else begin
    if (cnt != 0)
      cnt <= cnt - 1;
    else begin
      cnt <= 795;
      if (bitnum < 8) begin
        bitnum <= bitnum + 1;
        out[bitnum] = serial;
      end else begin
        new <= 1;
        reading <= 0;
      end
    end
  end
end

endmodule
